/* Generated automatically by the program `genopinit'
from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "rtl.h"
#include "flags.h"
#include "insn-config.h"
#include "recog.h"
#include "expr.h"
#include "optabs.h"
#include "reload.h"

void
init_all_optabs ()
{
  addv_optab->handlers[(int) (int) SImode].insn_code = CODE_FOR_addvsi3;
  addv_optab->handlers[(int) (int) DImode].insn_code = CODE_FOR_addvdi3;
  neg_optab->handlers[(int) SImode].insn_code = CODE_FOR_negsi2;
  negv_optab->handlers[(int) (int) SImode].insn_code = CODE_FOR_negvsi2;
  neg_optab->handlers[(int) DImode].insn_code = CODE_FOR_negdi2;
  negv_optab->handlers[(int) (int) DImode].insn_code = CODE_FOR_negvdi2;
  subv_optab->handlers[(int) (int) SImode].insn_code = CODE_FOR_subvsi3;
  sub_optab->handlers[(int) DImode].insn_code = CODE_FOR_subdi3;
  subv_optab->handlers[(int) (int) DImode].insn_code = CODE_FOR_subvdi3;
  if (HAVE_mulsi3)
    smul_optab->handlers[(int) SImode].insn_code = CODE_FOR_mulsi3;
  if (HAVE_mulvsi3)
    smulv_optab->handlers[(int) (int) SImode].insn_code = CODE_FOR_mulvsi3;
  smul_optab->handlers[(int) DImode].insn_code = CODE_FOR_muldi3;
  smulv_optab->handlers[(int) (int) DImode].insn_code = CODE_FOR_mulvdi3;
  umul_highpart_optab->handlers[(int) DImode].insn_code = CODE_FOR_umuldi3_highpart;
  and_optab->handlers[(int) DImode].insn_code = CODE_FOR_anddi3;
  extendtab[(int) DImode][(int) SImode][1] = CODE_FOR_zero_extendsidi2;
  ior_optab->handlers[(int) DImode].insn_code = CODE_FOR_iordi3;
  one_cmpl_optab->handlers[(int) DImode].insn_code = CODE_FOR_one_cmpldi2;
  xor_optab->handlers[(int) DImode].insn_code = CODE_FOR_xordi3;
  ashl_optab->handlers[(int) DImode].insn_code = CODE_FOR_ashldi3;
  lshr_optab->handlers[(int) DImode].insn_code = CODE_FOR_lshrdi3;
  ashr_optab->handlers[(int) DImode].insn_code = CODE_FOR_ashrdi3;
  if (HAVE_abssf2)
    absv_optab->handlers[(int) (int) SFmode].insn_code =
    abs_optab->handlers[(int) (int) SFmode].insn_code = CODE_FOR_abssf2;
  if (HAVE_absdf2)
    absv_optab->handlers[(int) (int) DFmode].insn_code =
    abs_optab->handlers[(int) (int) DFmode].insn_code = CODE_FOR_absdf2;
  if (HAVE_negsf2)
    negv_optab->handlers[(int) (int) SFmode].insn_code =
    neg_optab->handlers[(int) (int) SFmode].insn_code = CODE_FOR_negsf2;
  if (HAVE_negdf2)
    negv_optab->handlers[(int) (int) DFmode].insn_code =
    neg_optab->handlers[(int) (int) DFmode].insn_code = CODE_FOR_negdf2;
  if (HAVE_addsf3)
    addv_optab->handlers[(int) (int) SFmode].insn_code =
    add_optab->handlers[(int) (int) SFmode].insn_code = CODE_FOR_addsf3;
  if (HAVE_adddf3)
    addv_optab->handlers[(int) (int) DFmode].insn_code =
    add_optab->handlers[(int) (int) DFmode].insn_code = CODE_FOR_adddf3;
  if (HAVE_fix_truncdfdi2)
    fixtrunctab[(int) DFmode][(int) DImode][0] = CODE_FOR_fix_truncdfdi2;
  if (HAVE_fix_truncsfdi2)
    fixtrunctab[(int) SFmode][(int) DImode][0] = CODE_FOR_fix_truncsfdi2;
  if (HAVE_floatdisf2)
    floattab[(int) SFmode][(int) DImode][0] = CODE_FOR_floatdisf2;
  if (HAVE_floatdidf2)
    floattab[(int) DFmode][(int) DImode][0] = CODE_FOR_floatdidf2;
  if (HAVE_divsf3)
    sdiv_optab->handlers[(int) SFmode].insn_code = CODE_FOR_divsf3;
  if (HAVE_divdf3)
    sdiv_optab->handlers[(int) DFmode].insn_code = CODE_FOR_divdf3;
  if (HAVE_mulsf3)
    smulv_optab->handlers[(int) (int) SFmode].insn_code =
    smul_optab->handlers[(int) (int) SFmode].insn_code = CODE_FOR_mulsf3;
  if (HAVE_muldf3)
    smulv_optab->handlers[(int) (int) DFmode].insn_code =
    smul_optab->handlers[(int) (int) DFmode].insn_code = CODE_FOR_muldf3;
  if (HAVE_subsf3)
    subv_optab->handlers[(int) (int) SFmode].insn_code =
    sub_optab->handlers[(int) (int) SFmode].insn_code = CODE_FOR_subsf3;
  if (HAVE_subdf3)
    subv_optab->handlers[(int) (int) DFmode].insn_code =
    sub_optab->handlers[(int) (int) DFmode].insn_code = CODE_FOR_subdf3;
  if (HAVE_sqrtsf2)
    sqrt_optab->handlers[(int) SFmode].insn_code = CODE_FOR_sqrtsf2;
  if (HAVE_sqrtdf2)
    sqrt_optab->handlers[(int) DFmode].insn_code = CODE_FOR_sqrtdf2;
  if (HAVE_sminqi3)
    smin_optab->handlers[(int) QImode].insn_code = CODE_FOR_sminqi3;
  if (HAVE_uminqi3)
    umin_optab->handlers[(int) QImode].insn_code = CODE_FOR_uminqi3;
  if (HAVE_smaxqi3)
    smax_optab->handlers[(int) QImode].insn_code = CODE_FOR_smaxqi3;
  if (HAVE_umaxqi3)
    umax_optab->handlers[(int) QImode].insn_code = CODE_FOR_umaxqi3;
  if (HAVE_sminhi3)
    smin_optab->handlers[(int) HImode].insn_code = CODE_FOR_sminhi3;
  if (HAVE_uminhi3)
    umin_optab->handlers[(int) HImode].insn_code = CODE_FOR_uminhi3;
  if (HAVE_smaxhi3)
    smax_optab->handlers[(int) HImode].insn_code = CODE_FOR_smaxhi3;
  if (HAVE_umaxhi3)
    umax_optab->handlers[(int) HImode].insn_code = CODE_FOR_umaxhi3;
  extendtab[(int) DImode][(int) SImode][0] = CODE_FOR_extendsidi2;
  if (HAVE_addsi3)
    add_optab->handlers[(int) SImode].insn_code = CODE_FOR_addsi3;
  add_optab->handlers[(int) DImode].insn_code = CODE_FOR_adddi3;
  if (HAVE_subsi3)
    sub_optab->handlers[(int) SImode].insn_code = CODE_FOR_subsi3;
  if (HAVE_divsi3)
    sdiv_optab->handlers[(int) SImode].insn_code = CODE_FOR_divsi3;
  if (HAVE_udivsi3)
    udiv_optab->handlers[(int) SImode].insn_code = CODE_FOR_udivsi3;
  if (HAVE_modsi3)
    smod_optab->handlers[(int) SImode].insn_code = CODE_FOR_modsi3;
  if (HAVE_umodsi3)
    umod_optab->handlers[(int) SImode].insn_code = CODE_FOR_umodsi3;
  if (HAVE_divdi3)
    sdiv_optab->handlers[(int) DImode].insn_code = CODE_FOR_divdi3;
  if (HAVE_udivdi3)
    udiv_optab->handlers[(int) DImode].insn_code = CODE_FOR_udivdi3;
  if (HAVE_moddi3)
    smod_optab->handlers[(int) DImode].insn_code = CODE_FOR_moddi3;
  if (HAVE_umoddi3)
    umod_optab->handlers[(int) DImode].insn_code = CODE_FOR_umoddi3;
  extendtab[(int) HImode][(int) QImode][1] = CODE_FOR_zero_extendqihi2;
  extendtab[(int) SImode][(int) QImode][1] = CODE_FOR_zero_extendqisi2;
  extendtab[(int) DImode][(int) QImode][1] = CODE_FOR_zero_extendqidi2;
  extendtab[(int) SImode][(int) HImode][1] = CODE_FOR_zero_extendhisi2;
  extendtab[(int) DImode][(int) HImode][1] = CODE_FOR_zero_extendhidi2;
  if (HAVE_ffsdi2)
    ffs_optab->handlers[(int) DImode].insn_code = CODE_FOR_ffsdi2;
  extendtab[(int) HImode][(int) QImode][0] = CODE_FOR_extendqihi2;
  extendtab[(int) SImode][(int) QImode][0] = CODE_FOR_extendqisi2;
  extendtab[(int) DImode][(int) QImode][0] = CODE_FOR_extendqidi2;
  extendtab[(int) SImode][(int) HImode][0] = CODE_FOR_extendhisi2;
  extendtab[(int) DImode][(int) HImode][0] = CODE_FOR_extendhidi2;
  if (HAVE_abstf2)
    absv_optab->handlers[(int) (int) TFmode].insn_code =
    abs_optab->handlers[(int) (int) TFmode].insn_code = CODE_FOR_abstf2;
  if (HAVE_negtf2)
    negv_optab->handlers[(int) (int) TFmode].insn_code =
    neg_optab->handlers[(int) (int) TFmode].insn_code = CODE_FOR_negtf2;
  if (HAVE_addtf3)
    addv_optab->handlers[(int) (int) TFmode].insn_code =
    add_optab->handlers[(int) (int) TFmode].insn_code = CODE_FOR_addtf3;
  if (HAVE_fix_trunctfdi2)
    fixtrunctab[(int) TFmode][(int) DImode][0] = CODE_FOR_fix_trunctfdi2;
  if (HAVE_floatditf2)
    floattab[(int) TFmode][(int) DImode][0] = CODE_FOR_floatditf2;
  if (HAVE_floatunsdisf2)
    floattab[(int) SFmode][(int) DImode][1] = CODE_FOR_floatunsdisf2;
  if (HAVE_floatunsdidf2)
    floattab[(int) DFmode][(int) DImode][1] = CODE_FOR_floatunsdidf2;
  if (HAVE_floatunsditf2)
    floattab[(int) TFmode][(int) DImode][1] = CODE_FOR_floatunsditf2;
  if (HAVE_extendsfdf2)
    extendtab[(int) DFmode][(int) SFmode][0] = CODE_FOR_extendsfdf2;
  if (HAVE_extendsftf2)
    extendtab[(int) TFmode][(int) SFmode][0] = CODE_FOR_extendsftf2;
  if (HAVE_extenddftf2)
    extendtab[(int) TFmode][(int) DFmode][0] = CODE_FOR_extenddftf2;
  if (HAVE_divtf3)
    sdiv_optab->handlers[(int) TFmode].insn_code = CODE_FOR_divtf3;
  if (HAVE_multf3)
    smulv_optab->handlers[(int) (int) TFmode].insn_code =
    smul_optab->handlers[(int) (int) TFmode].insn_code = CODE_FOR_multf3;
  if (HAVE_subtf3)
    subv_optab->handlers[(int) (int) TFmode].insn_code =
    sub_optab->handlers[(int) (int) TFmode].insn_code = CODE_FOR_subtf3;
  abs_optab->handlers[(int) DImode].insn_code = CODE_FOR_absdi2;
  smax_optab->handlers[(int) DImode].insn_code = CODE_FOR_smaxdi3;
  smin_optab->handlers[(int) DImode].insn_code = CODE_FOR_smindi3;
  umax_optab->handlers[(int) DImode].insn_code = CODE_FOR_umaxdi3;
  umin_optab->handlers[(int) DImode].insn_code = CODE_FOR_umindi3;
  if (HAVE_maxdf3)
    smax_optab->handlers[(int) DFmode].insn_code = CODE_FOR_maxdf3;
  if (HAVE_mindf3)
    smin_optab->handlers[(int) DFmode].insn_code = CODE_FOR_mindf3;
  if (HAVE_maxsf3)
    smax_optab->handlers[(int) SFmode].insn_code = CODE_FOR_maxsf3;
  if (HAVE_minsf3)
    smin_optab->handlers[(int) SFmode].insn_code = CODE_FOR_minsf3;
  if (HAVE_cmpdf)
    cmp_optab->handlers[(int) DFmode].insn_code = CODE_FOR_cmpdf;
  if (HAVE_cmptf)
    cmp_optab->handlers[(int) TFmode].insn_code = CODE_FOR_cmptf;
  cmp_optab->handlers[(int) DImode].insn_code = CODE_FOR_cmpdi;
  bcc_gen_fctn[(int) EQ] = gen_beq;
  bcc_gen_fctn[(int) NE] = gen_bne;
  bcc_gen_fctn[(int) LT] = gen_blt;
  bcc_gen_fctn[(int) LE] = gen_ble;
  bcc_gen_fctn[(int) GT] = gen_bgt;
  bcc_gen_fctn[(int) GE] = gen_bge;
  bcc_gen_fctn[(int) LTU] = gen_bltu;
  bcc_gen_fctn[(int) LEU] = gen_bleu;
  bcc_gen_fctn[(int) GTU] = gen_bgtu;
  bcc_gen_fctn[(int) GEU] = gen_bgeu;
  bcc_gen_fctn[(int) UNORDERED] = gen_bunordered;
  bcc_gen_fctn[(int) ORDERED] = gen_bordered;
  setcc_gen_code[(int) EQ] = CODE_FOR_seq;
  setcc_gen_code[(int) NE] = CODE_FOR_sne;
  setcc_gen_code[(int) LT] = CODE_FOR_slt;
  setcc_gen_code[(int) LE] = CODE_FOR_sle;
  setcc_gen_code[(int) GT] = CODE_FOR_sgt;
  setcc_gen_code[(int) GE] = CODE_FOR_sge;
  setcc_gen_code[(int) LTU] = CODE_FOR_sltu;
  setcc_gen_code[(int) LEU] = CODE_FOR_sleu;
  setcc_gen_code[(int) GTU] = CODE_FOR_sgtu;
  setcc_gen_code[(int) GEU] = CODE_FOR_sgeu;
  setcc_gen_code[(int) UNORDERED] = CODE_FOR_sunordered;
  setcc_gen_code[(int) ORDERED] = CODE_FOR_sordered;
  movcc_gen_code[(int) SImode] = CODE_FOR_movsicc;
  movcc_gen_code[(int) DImode] = CODE_FOR_movdicc;
  movcc_gen_code[(int) SFmode] = CODE_FOR_movsfcc;
  movcc_gen_code[(int) DFmode] = CODE_FOR_movdfcc;
  mov_optab->handlers[(int) SFmode].insn_code = CODE_FOR_movsf;
  mov_optab->handlers[(int) DFmode].insn_code = CODE_FOR_movdf;
  mov_optab->handlers[(int) TFmode].insn_code = CODE_FOR_movtf;
  mov_optab->handlers[(int) SImode].insn_code = CODE_FOR_movsi;
  mov_optab->handlers[(int) DImode].insn_code = CODE_FOR_movdi;
  mov_optab->handlers[(int) QImode].insn_code = CODE_FOR_movqi;
  mov_optab->handlers[(int) HImode].insn_code = CODE_FOR_movhi;
  if (HAVE_reload_inqi)
    reload_in_optab[(int) QImode] = CODE_FOR_reload_inqi;
  if (HAVE_reload_inhi)
    reload_in_optab[(int) HImode] = CODE_FOR_reload_inhi;
  if (HAVE_reload_outqi)
    reload_out_optab[(int) QImode] = CODE_FOR_reload_outqi;
  if (HAVE_reload_outhi)
    reload_out_optab[(int) HImode] = CODE_FOR_reload_outhi;
  movstr_optab[(int) QImode] = CODE_FOR_movstrqi;
  clrstr_optab[(int) QImode] = CODE_FOR_clrstrqi;
}
